Package net.sf.saxon.query

## Class UnboundFunctionLibrary

- java.lang.Object
- - net.sf.saxon.query.UnboundFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class UnboundFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  An UnboundFunctionLibrary is not a real function library; rather, it is used to keep track of function calls that cannot yet be bound to a known declared function, but will have to be bound when all user-declared functions are available.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `UnboundFunctionLibrary()` | Create an UnboundFunctionLibrary

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] arguments, StaticContext env, java.util.List<java.lang.String> reasons)` | Identify a (namespace-prefixed) function appearing in the expression.
    `void` | `bindUnboundFunctionReferences​(XQueryFunctionBinder lib, Configuration config)` | Bind function calls that could not be bound when first encountered.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### UnboundFunctionLibrary

          public UnboundFunctionLibrary()

      Create an UnboundFunctionLibrary

  - ### Method Detail

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] arguments,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Identify a (namespace-prefixed) function appearing in the expression. This method is called by the XQuery parser to resolve function calls found within the query.

      Note that a function call may appear earlier in the query than the definition of the function to which it is bound. Unlike XSLT, we cannot search forwards to find the function definition. Binding of function calls is therefore a two-stage process; at the time the function call is parsed, we simply register it as pending; subsequently at the end of query parsing all the pending function calls are resolved. Another consequence of this is that we cannot tell at the time a function call is parsed whether it is a call to an internal (XSLT or XQuery) function or to an extension function written in Java.

      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the QName of the function being called
        `arguments` - May be null; if present, the length of the array must match the value of arity. Contains the expressions supplied statically in arguments to the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

        The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

        `env` - The static context of the function call
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        an Expression representing the function call. This will normally be a FunctionCall, but it may be rewritten as some other expression.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### bindUnboundFunctionReferences

          public void bindUnboundFunctionReferences​(XQueryFunctionBinder lib,
                                                    Configuration config)
                                             throws XPathException

      Bind function calls that could not be bound when first encountered. These will either be forwards references to functions declared later in the query, or errors. This method is for internal use.
      Parameters:
        `lib` - A library containing all the XQuery functions that have been declared; the method searches this library for this missing function call
        `config` - The Saxon configuration
      Throws:
        `XPathException` - if a function call refers to a function that has not been declared

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.